<template>
    <div>
        <div class="header-block header-with-menu">
            <h3 class="header">Лента операций</h3>
            <div class="pos-menu pos-menu-status">
                <button class="pos-menu-button"
                        :class="{active: displayAllPartners}"
                        id="pos-menu-button"
                        @click="displayAllPartners = !displayAllPartners">Фильтры ({{Object.keys(filter).length || 'Все'}})</button>
                <div class="row menu" id="pos-menu" :class="{opened: displayAllPartners}">
                    <!--Сюда прописываем статусы, например:-->
                    <a href="#" class="item" :class="{active: filter['completed']}" @click.prevent="setFilter('completed')">
                        <div class="status-green"></div>
                        Займ погашен
                    </a>
                    <a href="#" class="item" :class="{active: filter['processing']}" @click.prevent="setFilter('processing')">
                        <div class="status-orange"></div>
                        Возврат в обработке
                    </a>
                    <a href="#" class="item" :class="{active: filter['active']}" @click.prevent="setFilter('active')">
						<div class="status-blue"></div>
                        Активен
                    </a>
                    <a href="#" class="item" :class="{active: filter['returned']}"  @click.prevent="setFilter('returned')">
						<div class="status-red"></div>
                        Товар возвращён
                    </a>
                </div>
                <div class="lag"></div>
                <input type="text" name="search" id="search" placeholder="Поиск по ленте" v-model="search" class="search"/>
            </div>
            <div class="clear-fix-block"></div>
        </div>
        <div class="white-block" v-if="$interface.viewport !== 'mobile'">
            <div class="padding adaptive-hidden">
                <div class="row table-header">
                    <div :class="['columns two sum', {'top-arrow': dateSort === 'ASC'}]"
                         @click="dateSort = dateSort === 'DESC' ? 'ASC' : 'DESC'"
                    >
                        Дата
                    </div>
                    <div class="columns three">Магазин</div>
                    <div class="columns two">Сумма</div>
                    <div class="columns three">Статус</div>
                    <div class="columns one">Договор</div>
                </div>
            </div>
            <div v-for="operation in operations"
                 :key="operation.id"
                 :set="(
                    isOperationType = operation.contract_number
                )"
                 class="question-block q-blue q-default"
            >
                <div class="question padding">
                    <div class="row" @click="expand(operation)">
                        <div class="columns two">
                            <span class="adaptive-show">
                                Дата
                            </span>
                            {{$dayjs(operation.date).format('DD.MM.YYYY (HH:mm)')}}
                        </div>
                        <div class="columns three">
                            <span class="adaptive-show">
                                Магазин
                            </span>
                            <template v-if="operation.status">
                                {{operation|shopName}}
                            </template>
                            <template v-else>
                                Пополнение
                            </template>
                        </div>
                        <div class="columns two">
                            <span class="adaptive-show">
                                Сумма
                            </span>
                            <span style="white-space: nowrap">
                                {{operation.sum|currency}} &#8381;
                            </span>
                        </div>
                        <div class="columns three">
							<template v-if="operation.shop.name">
								<span class="adaptive-show">Статус</span>
								<span :class="status(operation.status)"></span>
								{{statusText(operation.status)}}
							</template>
                        </div>
                        <div class="columns one adaptive-right" @click.stop="documents(operation.id)">
                            <template v-if="isOperationType">
                                <span class="adaptive-show">Договор</span>
                                <a class="docs"></a>
                            </template>
                        </div>
                        <div class="columns one adaptive-right" >
                            <img src="static/img/pos/arrow.png"
                                 alt=""
                                 class="faq-arrow"
                                 :class="{active: operation.expand}"
                                 />
                        </div>
                    </div>

                </div>

                <transition name="fade">
                    <operation-details :operation="operation" v-if="operation.expand"/>
                </transition>

            </div>

            <div v-if="!operations.length" class="question-block q-blue q-default">
                <div class="question padding operations-tape-empty-info">
                    Пока нет ни одной совершенной вами операции
                </div>
            </div>

        </div>
        <div v-else class="loan-info">
            <div class="list-item white-block" v-for="operation in operations" :set="(
                    isOperationType = operation.contract_number
                )">
                <div class="padding" style="padding-bottom: 20px;">
                    <div class="row">
                        <div class="columns six dotted-line">
                            <span class="left-block">Дата</span>
                            <span class="right-block">{{ $dayjs(operation.date).format('DD.MM.YYYY (HH:mm)') }}</span>
                        </div>
                        <div class="columns six dotted-line">
                            <span class="left-block">Магазин</span>
                            <span class="right-block">{{operation|shopName}}</span>
                        </div>
                    </div>

                    <div class="row">
                        <div class="columns six dotted-line">
                            <span class="left-block">Сумма</span>
                            <span class="right-block"> {{operation.sum|currency}} &#8381;</span>
                        </div>
                        <div class="columns six dotted-line">
                            <span class="left-block">Статус</span>
                            <span class="right-block" :class="`mobile-` + status(operation.status)">{{statusText(operation.status)}}</span>
                        </div>
                    </div>


                    <transition name="fade">
                        <operation-details :operation="operation" v-if="operation.expand"/>
                    </transition>

                    <div class="row loan-history">
                        <div class="columns six docs">
                                        <span @click.stop="documents(operation.id)" class="link documents"  v-if="isOperationType">
                                            Договор
                                        </span>
                            <span class="link" @click="expand(operation)" style="float:right;">
                                            {{operation.expand ? 'Свернуть' : 'Подробнее'}}
                                        </span>
                        </div>

                    </div>

                </div>



            </div>
        </div>
    </div>
</template>

<script>
    import operationDetails from './Details.vue';
  export default {
    name: 'paymentHistory',
    components: {
      operationDetails,
    },
    data () {
      return {
        displayAllPartners: false,
        filter: {

        },
		  sortOrder: {
			  num: 'ASC',
			  dateFrom: 'ASC',
			  dateTo: 'ASC',
			  sum: 'ASC',
			  status: 'ASC'
          },
        search: '',
          dateSort: 'DESC',
      }
    },
    filters: {
      shopName(op) {
        return `${op?.shop?.name || ''}`;
      }
    },
    computed: {
      operations () {
        let data = [];
        let filter = false;

        const operations = this.$installment.operations;


          const compare = (a,b)  => {
              const date1 = this.$dayjs(a.date);
              const date2 = this.$dayjs(b.date);
              if (date1 < date2)
                  return this.dateSort === 'DESC' ? 1 : -1;
              if (date1 > date2)
                  return this.dateSort === 'DESC' ? -1 : 1;
              return 0;
          }



        //фильтрация по статусу
        if (Object.keys(this.filter).length) {
          filter = true;
            data = operations.sort(compare).filter(/** @param {INSTALLMENT_OPERATIONS} op **/(op) => {
              return Object.keys(this.filter).includes(op.status)
            })
        } else {
          data = operations.sort(compare);
        }

        // фильтрация по поисковому запросу
        if (this.search) {
          filter = true;
          data = data.filter(/**@param {INSTALLMENT_OPERATIONS} op**/(op) => {
            op.shop.name = op.shop.name || '';
            op.shop.merchant.category = op.shop.merchant.category || '';
            op.shop.merchant.description = op.shop.merchant.description || '';
            op.shop.merchant.website = op.shop.merchant.website || '';
            op.shop.address = op.shop.address || '';

            return op.shop.name.toLowerCase().indexOf(this.search.toLowerCase()) > -1 ||
              op.shop.merchant.category.toLowerCase().indexOf(this.search.toLowerCase()) > -1 ||
              op.shop.merchant.description.toLowerCase().indexOf(this.search.toLowerCase()) > -1 ||
              op.shop.merchant.website.toLowerCase().indexOf(this.search.toLowerCase()) > -1 ||
              op.shop.address.toLowerCase().indexOf(this.search.toLowerCase()) > -1
          })
        }

        if (filter) {
          return data;
        }

        return operations.sort(compare);
      }
    },
    methods: {
    	searchByQuery() {

        },

      documents (id) {
        this.$store.dispatch('GET_INSTALLMENT_DOC', id).then((response) => {
          this.$toastr.success('Загрузка договора...');
        }).catch((e) => {
          console.warn(e);
          this.$toastr.error('Не удалось получить договор', 'Ошибка');
        })
      },

      status (status) {
        const c = {
			active: 'status-blue',
			repaid: 'status-red',
			processing: 'status-orange',
			returned: 'status-red',
            completed: 'status-green'
        }[status];

        return [c];
      },
      statusText(status) {
        /*если нет статуса*/
    	if(!status) {
    		status = 'replenishment';
        }
        return {
          active: 'Активен',
          processing: 'Возврат в обработке',
          returned: 'Товар возвращён',
          repaid: 'Погашен',
            completed: "Займ погашен"
        }[status];
      },
      setFilter (status_id) {
        if (this.filter[status_id]) {
          this.$delete(this.filter, status_id);
        } else {
          this.$set(this.filter, status_id, true);
        }
        this.displayAllPartners = false;
      },
      /**
       *
       * @param {INSTALLMENT_OPERATIONS} o
       */
      expand(o) {
       this.$set(o, 'expand', !o.expand);
      },

		runSort(sortType) {

        },
    },

      created() {
    	console.log('operations:', this.operations)
      },
  }
</script>

<style scoped lang="scss">
    img.faq-arrow {
        transition-duration: 0.3s;
        &.active {
            transform: rotate(0deg);
        }
    }
    .sum {
        background: url("/lk/static/img/history/arrow.png") no-repeat 100% 5px;
        padding-right: 15px;
        cursor: pointer;
        &.top-arrow {
            background-position: 100% -90px
        }
    }
    .operations-tape-empty-info {
        justify-content: center;
    }
    .list-item {
        margin-bottom: 30px !important;
    }


    .mobile-status{
        &-blue, &-red, &-orange, &-green {
           &:before {
               display: inline-block;
               width: 10px;
               height: 10px;
               border-radius: 10px;
               margin-right: 10px;
               content: '';
           }
        }

        &-red:before {
            background: #ff4a57 !important;
        }

        &-orange:before {
            background: #ffbf29 !important;
        }

        &-green:before {
            background: #02cc20 !important;
        }

        &-blue:before {
            background: #198af2 !important;
        }
    }

</style>

